import type { GetServerSideProps, NextPage } from "next";
import Head from "next/head";
import Link from "next/link";
import { useRouter } from "next/router";
import { FormEvent, useEffect, useState } from "react";
import { ProductItemType } from "../../components/ProductItem";


interface Props {
  allProducts: ProductItemType[]
}

const Shop: NextPage<Props> = ({ allProducts }) => {
  const router = useRouter()
  const { query } = useRouter()

  const [data, setData] = useState(allProducts)

  useEffect(() => {
    setData(allProducts)
  }, [query])


  const [searchValue, setSearchValue] = useState('')

  const onSubmit = (e: FormEvent) => {
    e.preventDefault()
    delete query.search
    router.push({
      query: {
        ...router.query,
        search: searchValue
      }
    })
    setSearchValue('')
  }

  return (
    <>
      <Head>
        <title>Store</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <div className="bg0 m-t-23 p-b-140">
        <div className="container">
          <div className="flex-w flex-sb-m p-b-52">
            <div className="flex-w flex-l-m filter-tope-group m-tb-10">
              <Link href={"/shop"}>
                <button
                  className={`stext-106 cl6 hov1 bor3 trans-04 m-r-32 m-tb-5 ${query.gender_like === undefined ? 'how-active1' : ''}`}
                  data-filter="*"
                >
                  All Products
                </button>
              </Link>

              <button
                className={`stext-106 cl6 hov1 bor3 trans-04 m-r-32 m-tb-5 ${query.gender_like === 'women' ? 'how-active1' : ''}`}
                data-filter=".women"
                onClick={() => {
                  delete query.gender_like
                  router.push({
                    query: {
                      ...router.query,
                      gender_like: "women"
                    }
                  })
                }}
              >
                Women
              </button>

              <button className={`stext-106 cl6 hov1 bor3 trans-04 m-r-32 m-tb-5 ${query.gender_like === 'man' ? 'how-active1' : ''}`} data-filter=".men"
                onClick={() => {
                  delete query.gender_like
                  router.push({
                    query: {
                      ...router.query,
                      gender_like: "man"
                    }
                  })
                }}
              >
                Men
              </button>

            </div>

            <div className="flex-w flex-c-m m-tb-10">
              <div className="flex-c-m stext-106 cl6 size-105 bor4 pointer hov-btn3 trans-04 m-tb-4 js-show-search show-search">
                <i className="icon-search cl2 m-r-6 fs-15 trans-04 zmdi zmdi-search"></i>
                Search
              </div>
            </div>

            {/* search */}
            <form className="panel-search w-full p-t-10 p-b-15" onSubmit={onSubmit}>
              <div className="bor8 dis-flex p-l-15">
                <button className="size-113 flex-c-m fs-16 cl2 hov-cl1 trans-04">
                  <i className="zmdi zmdi-search"></i>
                </button>

                <input
                  className="mtext-107 cl2 size-114 plh2 p-r-15"
                  type="text"
                  name="search-product"
                  placeholder="Search"
                  value={searchValue}
                  onChange={(e) => setSearchValue(e.target.value)}
                />
              </div>
            </form>
          </div>

          <div className="row isotope-grid">

            {data.map((i) => (
              <div className="col-sm-6 col-md-4 col-lg-3 p-b-35 isotope-item women" key={i.id}>
                <div className="block2">
                  <div className="block2-pic hov-img0">
                    <img src={i.img} alt="IMG-PRODUCT" />

                    <a
                      href={`shop/${i.id}`}
                      className="block2-btn flex-c-m stext-103 cl2 size-102 bg0 bor2 hov-btn1 p-lr-15 trans-04 js-show-modal1"
                    >
                      View Details
                    </a>
                  </div>

                  <div className="block2-txt flex-w flex-t p-t-14">
                    <div className="block2-txt-child1 flex-col-l ">
                      <a
                        href="product-detail.html"
                        className="stext-104 cl4 hov-cl1 trans-04 js-name-b2 p-b-6"
                      >
                        {i.title}
                      </a>

                      <span className="stext-105 cl3">{i.price}</span>
                    </div>
                  </div>
                </div>
              </div>
            ))}
          </div>
        </div>
      </div>
    </>
  );
};

export const getServerSideProps: GetServerSideProps = async ({ query }) => {
  const { gender_like, search } = query

  const fillteredRes = await fetch(`https://boutique-server-api.herokuapp.com/products?${search && `q=${search}`}&${query.gender_like && `gender_like=${gender_like}`}`)
  const allProducts = await fillteredRes.json()

  return {
    props: {
      allProducts,
    }
  }
}

export default Shop;
